;**********************************************************************
;                                                                     *
;    Filename:	    AUTO_CH.asm                                       *
;    Date:          27.09.2004                                        *
;    File Version:  1.2                                               *
;                                                                     *
;    Author:        BY GARMASH G.V.                                   *
;    Company:                                                         *
;                                                                     * 
;                                                                     *
;**********************************************************************

	list		p=16f73		; list directive to define processor
	#include	<p16f73.inc>	; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC



;***** VARIABLE DEFINITIONS * IRQ *****

w_temp			EQU	0x20		; variable used for context saving
w_temp1			EQU	0xA0		; reserve bank1 equivalent of w_temp 
status_temp		EQU	0x21		; variable used for context saving
pclath_temp		EQU	0x22		; variable used for context saving

;********* 1 WIRE************

fCOUNTER:   	EQU 0x23   		;     .
fCOUNTER2:  	EQU	0x24   		; 2.
fBIT_CNT:   	EQU	0x25		;   .
fBYTE_CNT:  	EQU	0x26  		;   .
fTEMP:      	EQU	0x27  		;      .
CRC:        	EQU	0x28  		;  .
#define   _1WIRE    PORTA,4 ;   MicroLAN.

;*****************************

FLAG			EQU	0x29		;   

#define   FLAG_CHANGE_LEVEL    		FLAG,0 ;
#define   FLAG_CHANGE_LEVEL_1    	FLAG,1 ;  
#define   FLAG_BEEP			   		FLAG,2 ;  
#define   FLAG_3		   	FLAG,3 ;  
#define   FLAG_4   		FLAG,4 ;  FLAG 
#define   FLAG_5    	FLAG,5 ;  FLAG 
#define   FLAG_6    	FLAG,6 ;  FLAG 
#define   FLAG_7    	FLAG,7 ;  FLAG 

;***************TEMP***************

TEMP			EQU	0x2A
TEMP1			EQU	0x2B
TEMP2			EQU	0x2C

;********** I2C *************

_i2c_byte		EQU	0x2D
_tmp			EQU	0x2E
EE_DATA			EQU	0x2F
EE_ADDR			EQU	0x30

; ***********
#define   SCL   PORTA,2 ; I2C SCL PIN 
#define   SDA   PORTA,5 ; I2C SDA PIN 

#define   TRIS_SCL   TRISA^80,2 ; I2C SCL PIN 
#define   TRIS_SDA   TRISA^80,5 ; I2C SDA PIN

;********   I2C ************* 
       							;    		| 8| 4| 2| 1| 8| 4| 2| 1| 
SECONDS		EQU 0x31	; 		|CH| 10 SEC |  SECOND   |  00-59
MINUTES		EQU 0x32	; 		| 0| 10 MIN |  MINUTS   |  00-59
HOURS		EQU 0x33	; 		 |12/24| -|10hr |  HOUR     |  00-23/1-12 ;BIT8 = 0-24 HOUR
DAY			EQU 0x34	;  	| 0| 0| 0| 0| 0 | DAY   |  1-7	
DATE		EQU 0x35	; 	| 0| 0|10DAT|    DATE   |  1-31
MONTH		EQU 0x36	; 			| 0| 0| 0|10|   MONTH   |  1-12
YEAR		EQU 0x37	;         	| 10 YEAR   |    YEAR   |  00-99
						;				|OUT|0|0|SQWE|0|0|RS1|RS0|

;*********** BEEP **************

#define   BEEP_PIN		PORTC,0
#define   KEY1_PIN		PORTB,1
#define   KEY2_PIN		PORTB,2
#define   IN_N_PIN		PORTB,0

;*********** DISPLAY ***********
#define   SEGMENT_1		PORTB,6
#define   SEGMENT_2		PORTB,5
#define   SEGMENT_3		PORTB,4
#define   SEGMENT_4		PORTB,3
#define   SEGMENT_5		PORTB,7


#define   SEGMENT_A		PORTC,6
#define   SEGMENT_B		PORTC,7
#define   SEGMENT_C		PORTC,3
#define   SEGMENT_D		PORTC,1
#define   SEGMENT_E		PORTC,4
#define   SEGMENT_F		PORTC,2
#define   SEGMENT_G		PORTC,5
;*********** DASPLAY RAM ******

DISPLAY_S1			EQU 0x38
DISPLAY_S2			EQU 0x39
DISPLAY_S3			EQU 0x3A
DISPLAY_S4			EQU 0x3B
DISPLAY_S5			EQU 0x3C



fROM_ID0			EQU 0x3D
fROM_ID1			EQU 0x3E
fROM_ID2			EQU 0x3F
fROM_ID3			EQU 0x40
fROM_ID4			EQU 0x41
fROM_ID5			EQU 0x42
fROM_ID6			EQU 0x43
fROM_ID7			EQU 0x44

cicle 			EQU 0x45	;   

MENU_LEVEL			EQU 0x46

R0		EQU 0x47
R1		EQU 0x48
R2		EQU 0x49
R3		EQU 0x4A
R4		EQU 0x4B
R5		EQU 0x4C

LIGHT			EQU 0x4D

CNT_KEY1		EQU 0x4E
CNT_KEY2		EQU 0x4F

POWER_LEVEL_BAT		EQU 0x50
CNT_BEEP		EQU 0x51

TTEMP			EQU 0x52
DECIMAL			EQU 0x53

TEMP_CICLE1		EQU 0x54
TEMP_CICLE2		EQU 0x55

COUNT_N1		EQU 0x56
COUNT_N2		EQU 0x57
N_COUNT1		EQU 0x58
N_COUNT2		EQU 0x59

LONG_COUNT_N1		EQU 0x5A
LONG_COUNT_N2		EQU 0x5B
LONG_N_COUNT1		EQU 0x5C
LONG_N_COUNT2		EQU 0x5D

COUNT_IRQ			EQU 0x5E
LONG_COUNT_IRQ		EQU 0x5F

;            			
;***************
BANK0   	macro				;------------------------------------------;
				BCF	STATUS,RP1
				BCF	STATUS,RP0
			endm
;***************
BANK1   	macro				;------------------------------------------;
				BCF	STATUS,RP1
				BSF	STATUS,RP0
			endm
;***************
BANK2   	macro				;------------------------------------------;
				BSF	STATUS,RP1
				BCF	STATUS,RP0
			endm
;***************
BANK3   	macro				;------------------------------------------;
				BSF	STATUS,RP1
				BSF	STATUS,RP0
			endm
;***************



;**********************************************************************
			ORG     0x000             ; processor reset vector

			clrf    PCLATH            ; ensure page bits are cleared
  			goto    START              ; go to beginning of program
		

;**********************************************************************

			ORG     0x004             ; interrupt vector location

			movwf   w_temp            ; save off current W register contents
			movf	STATUS,w          ; move status register into W register
			bcf     STATUS,RP0        ; ensure file register bank set to 0
			movwf	status_temp       ; save off contents of STATUS register
			movf	PCLATH,w	  ; move pclath register into w register
			movwf	pclath_temp	  ; save off contents of PCLATH register

		movlw HIGH RETIRQ 	;load high 8-bit address of Table
		movwf PCLATH
;   
		BTFSS	INTCON,INTF
   		GOTO 	IRQ_TIMER
		BCF		INTCON,INTF				
;     


		BTFSS	PIR1,TMR2IF
		GOTO	RETIRQ

		INCFSZ	COUNT_N1,F
		GOTO	RETIRQ_INT


		INCF	COUNT_N2,F


RETIRQ_INT

		INCFSZ	LONG_COUNT_N1,F
		GOTO	END_IRQ_INT


		INCF	LONG_COUNT_N2,F




END_IRQ_INT


		BCF		PIR1,TMR2IF
		CLRF	TMR2

		GOTO	RETIRQ

IRQ_TIMER 
;   

		BCF	INTCON,T0IF	; RESET FLAG TIMER


		CLRF	TMR0
;   256
		MOVLW	.22	;   +1      
		MOVWF	TMR0		;   25.6MKS+2,4= 29 MKS

		INCF	COUNT_IRQ,F
		MOVLW	.20
		XORWF	COUNT_IRQ,W
		BTFSS	STATUS,Z
		GOTO	IRQ_TIMER_1


		CLRF	COUNT_IRQ  ; 0,3 SEC ON CICLE

		MOVF	COUNT_N1,W
		MOVWF	N_COUNT1
		MOVF	COUNT_N2,W
		MOVWF	N_COUNT2
		CLRF	COUNT_N1
		CLRF	COUNT_N2



IRQ_TIMER_1

		INCF	LONG_COUNT_IRQ,F
		MOVLW	.201
		XORWF	LONG_COUNT_IRQ,W
		BTFSS	STATUS,Z
		GOTO	RETIRQ


		CLRF	LONG_COUNT_IRQ ; 3 SEC ON CICLE

		MOVF	LONG_COUNT_N1,W
		MOVWF	LONG_N_COUNT1
		MOVF	LONG_COUNT_N2,W
		MOVWF	LONG_N_COUNT2
		CLRF	LONG_COUNT_N1
		CLRF	LONG_COUNT_N2

		GOTO	RETIRQ



RETIRQ
			bcf     STATUS,RP0        ; ensure file register bank set to 0
			movf	pclath_temp,w	  ; retrieve copy of PCLATH register
			movwf	PCLATH		  ; restore pre-isr PCLATH register contents
			movf    status_temp,w     ; retrieve copy of STATUS register
			movwf	STATUS            ; restore pre-isr STATUS register contents
			swapf   w_temp,f
			swapf   w_temp,w          ; restore pre-isr W register contents
			retfie                    ; return from interrupt
;**********************************************************************


;=================== LCD TABLE ==================================
;     
; 0 - ........ 7 - 
; :   W   0  7F
; :   W   
		movlw HIGH LCDTable	;load high 8-bit
							;address of Table
		movwf PCLATH 		;into PCLATH



LCDTable
	  ANDLW		b'00001111'	
	    				
            addwf      PCL,F        ; W + PC -> PC
;            retlw      ; AFBDGCHE = '8,'	hXX            
            retlw      b'00100000' ; 0
            retlw      b'01110110' ; 1
            retlw      b'00001100' ; 2
            retlw      b'00010100' ; 3
            retlw      b'01010010' ; 4
            retlw      b'10010000' ; 5
            retlw      b'10000000' ; 6
            retlw      b'00110110' ; 7
            retlw      b'00000000' ; 8
            retlw      b'00010000' ; 9
            retlw      b'11111110' ;  
            retlw      b'11111110' ;  
            retlw      b'11111110' ;  
            retlw      b'10001000' ; C
            retlw      b'11100100' ; u
            retlw      b'11000110' ; n
    
;**********************************************************************




;##########################################################
;   
START 
		CALL	_INIT

		CLRF	EE_ADDR				;        (
		CALL	DSTIME_READ_BYTE
		BTFSC	EE_DATA,7
		CALL 	INIT_TIMER				;  ?  

		CLRF	MENU_LEVEL






START_MAIN
		MOVLW	.252
		BTFSS	FLAG_BEEP
		MOVWF	CNT_BEEP


		BTFSC	FLAG_BEEP
		BSF		BEEP_PIN
		BTFSS	FLAG_BEEP
		BCF		BEEP_PIN


		CALL	DISPLAY_CICLE	; 


		INCFSZ	TEMP1,F
		GOTO	START_MAIN_2

;   

		INCFSZ		CNT_BEEP,F
		GOTO	START_MAIN_BEEP
		BCF    	FLAG_BEEP




START_MAIN_BEEP







;    -  10 


		BTFSS	FLAG_CHANGE_LEVEL	; CME   
		GOTO	START_MAIN_1A

		INCF	MENU_LEVEL,F
		MOVLW	b'00000011'
		ANDWF	MENU_LEVEL,F
		BCF		FLAG_CHANGE_LEVEL

START_MAIN_1A

		BTFSS	FLAG_CHANGE_LEVEL_1	; CME    
		GOTO	START_MAIN_1

		INCF	MENU_LEVEL,F
		MOVLW	b'000000111'
		ANDWF	MENU_LEVEL,F
		BCF		FLAG_CHANGE_LEVEL_1




START_MAIN_1

		CALL	SCAN_KEY ; 10 MS


START_MAIN_2


; STANDART MODE

		MOVLW	.0
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	TIME_MODE

		MOVLW	.1
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	VOLT_MODE

		MOVLW	.2
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	TEMPERATUR_MODE

		MOVLW	.3
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	TAHOMETR_MODE


		MOVLW	.4
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	LIGHT_MODE

		MOVLW	.5
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	CHANGE_MIN_MODE

		MOVLW	.6
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	CHANGE_HOUR_MODE

		MOVLW	.7
		XORWF	MENU_LEVEL,W
		BTFSC	STATUS,Z
		CALL	LONG_TAHOMETR_MODE

;SERVICE MODE



		GOTO	START_MAIN

;**********************************************************************
;*********    *********************************************
;**********************************************************************
;**********************************************************************
TAHOMETR_MODE

		INCFSZ	TEMP,F	;  
		RETURN



		MOVLW	.255
		MOVWF	DISPLAY_S1		

		MOVLW	b'11000111'
		MOVWF	DISPLAY_S4

		MOVLW	b'11110101'
		MOVWF	DISPLAY_S5

;N_COUNT1
; .
; R1:R0 = R3:R2 / R5:R4
;  R3:R2 .

		MOVF	N_COUNT1,W
		MOVWF	R2
		
		MOVLW	.10
		MOVWF	R4
		
		CLRF	R5
		CALL	div_16
		
		MOVF	R2,W
		CALL	LCDTable
		MOVWF	DISPLAY_S2

		MOVF	R0,W
		CALL	LCDTable
		MOVWF	DISPLAY_S3

;> 4000 .
		MOVLW	.4
		SUBWF	R0,W
		BTFSC	STATUS,C
		BSF		FLAG_BEEP



			RETURN
;**********************************************************************
LONG_TAHOMETR_MODE



;		MOVLW	.255
;		MOVWF	DISPLAY_S1
;		MOVWF	DISPLAY_S2
;		MOVWF	DISPLAY_S3
;

		MOVLW	b'11000111'
		MOVWF	DISPLAY_S4

		MOVLW	b'01111101'
		MOVWF	DISPLAY_S5


		incfsz	TEMP2,f
;		BTFSS	STATUS,Z
		RETURN





;		BTFSS	FLAG_CHANGE_LEVEL	; CME    
;		RETURN
;
;		BCF		FLAG_CHANGE_LEVEL

;  
;LONG_N_COUNT1
;LONG_N_COUNT2
; .
; R1:R0 = R3:R2 / R5:R4
;  R3:R2 .
		MOVF	LONG_N_COUNT1,W
		MOVWF	R2

		MOVF	LONG_N_COUNT2,W
		MOVWF	R3
		
		MOVLW	.10
		MOVWF	R4
		CLRF	R5

		CALL	div_16_L
		
		MOVF	R2,W
		CALL	LCDTable
		MOVWF	DISPLAY_S1

		MOVF	R1,W
		MOVWF	R3

		MOVF	R0,W
		MOVWF	R2

		MOVLW	.10
		MOVWF	R4
		CLRF	R5
		CALL	div_16_L

		MOVF	R2,W
		CALL	LCDTable
		MOVWF	DISPLAY_S2

		MOVF	R0,W
		CALL	LCDTable
		MOVWF	DISPLAY_S3


;> 4000 .
		MOVLW	.4
		SUBWF	R0,W
		BTFSC	STATUS,C
		BSF		FLAG_BEEP


			RETURN

;**********************************************************************
CHANGE_HOUR_MODE

		CALL	TIME_MODE


		MOVLW	.255
		MOVWF	DISPLAY_S1
		MOVWF	DISPLAY_S2	
		


		MOVF	TEMP1,W
		BTFSS	STATUS,Z
		RETURN

		BTFSS	FLAG_CHANGE_LEVEL	; CME    
		RETURN

		BCF		FLAG_CHANGE_LEVEL

;  

		MOVLW	.2
		MOVWF	EE_ADDR			; HOUR

		CALL	DSTIME_READ_BYTE	

		MOVF	EE_DATA,W

		ANDLW	b'00001111'  ;HOUR
		MOVWF	R0

		SWAPF	EE_DATA,W

		ANDLW	b'00001111'	; DES HOUR
		MOVWF	R2

		INCF	R0,F
		
		MOVLW	.10
		XORWF	R0,W
		
		BTFSC	STATUS,Z
		GOTO	INC_DES_HOUR


		MOVF	R2,W
		XORLW	.2
		BTFSS	STATUS,Z
		GOTO	INC_DES_HOUR_2

		MOVF	R0,W
		XORLW	.4
		BTFSC	STATUS,Z
		GOTO	INC_DES_HOUR_1



INC_DES_HOUR_2		
		SWAPF	R2,W
		IORWF	R0,W
		MOVWF	EE_DATA
		CALL	DSTIME_SAVE_BYTE

		RETURN


INC_DES_HOUR

		CLRF	R0			

		INCF	R2,F
		
		MOVLW	.3
		XORWF	R2,W
		
		BTFSC	STATUS,Z
		GOTO	INC_DES_HOUR_1
		
		SWAPF	R2,W
		IORWF	R0,W
		MOVWF	EE_DATA
		CALL	DSTIME_SAVE_BYTE

		RETURN

INC_DES_HOUR_1
		CLRF	EE_DATA
		CALL	DSTIME_SAVE_BYTE

		RETURN

;**********************************************************************


;**********************************************************************
CHANGE_MIN_MODE

		CALL	TIME_MODE


		MOVLW	.255
		MOVWF	DISPLAY_S4
		MOVWF	DISPLAY_S3	
		


		MOVF	TEMP1,W
		BTFSS	STATUS,Z
		RETURN

		BTFSS	FLAG_CHANGE_LEVEL	; CME    
		RETURN

		BCF		FLAG_CHANGE_LEVEL

;  

		MOVLW	.1
		MOVWF	EE_ADDR			; MIN

		CALL	DSTIME_READ_BYTE	

		MOVF	EE_DATA,W

		ANDLW	b'00001111'  ;MIN
		MOVWF	R0

		SWAPF	EE_DATA,W

		ANDLW	b'00001111'	; DES MIN
		MOVWF	R2

		INCF	R0,F
		
		MOVLW	.10
		XORWF	R0,W
		
		BTFSC	STATUS,Z
		GOTO	INC_DES_MIN
		
		SWAPF	R2,W
		IORWF	R0,W
		MOVWF	EE_DATA
		CALL	DSTIME_SAVE_BYTE

		RETURN


INC_DES_MIN

		CLRF	R0			

		INCF	R2,F
		
		MOVLW	.6
		XORWF	R2,W
		
		BTFSC	STATUS,Z
		GOTO	INC_DES_MIN_1
		
		SWAPF	R2,W
		IORWF	R0,W
		MOVWF	EE_DATA
		CALL	DSTIME_SAVE_BYTE

		RETURN

INC_DES_MIN_1
		CLRF	EE_DATA
		CALL	DSTIME_SAVE_BYTE

		RETURN

;**********************************************************************


LIGHT_MODE

		MOVLW	.255
		MOVWF	DISPLAY_S4
		MOVWF	DISPLAY_S5	
		MOVLW	b'11101001'
		MOVWF	DISPLAY_S3

		MOVLW	b'11011111'
		MOVWF	DISPLAY_S2

		MOVLW	.5
		SUBWF	LIGHT,W
		MOVWF	R0
		RRF		R0,W

		CALL	LCDTable
		MOVWF	DISPLAY_S1



		MOVF	TEMP1,W
		BTFSS	STATUS,Z
		RETURN

		BTFSS	FLAG_CHANGE_LEVEL	; CME    
		RETURN

		BCF		FLAG_CHANGE_LEVEL

		DECF	LIGHT,F   ; (5 - 50_)
		MOVF	LIGHT,W
		XORLW	.5
		MOVLW	.25
		BTFSC	STATUS,Z
		MOVWF	LIGHT

		DECF	LIGHT,F   ; (5 - 50_)
		MOVF	LIGHT,W
		XORLW	.5
		MOVLW	.25
		BTFSC	STATUS,Z
		MOVWF	LIGHT


		RETURN

;**********************************************************************

VOLT_MODE
		INCFSZ	TEMP,F	;  
		RETURN


GET_VOLUME_POWER
		BCF		ADCON0,ADON		; DISABLE ADC
		
		BCF		ADCON0,CHS0		; SELECT CHANNEL 0
		BCF		ADCON0,CHS1
		BCF		ADCON0,CHS2

		BSF		ADCON0,ADON		; ENABLE ADC
		
		CALL	DELAY_15MKS		; 16 MKS
		
		BSF		ADCON0,GO_DONE	; START DAC
WAIT_CH0_DAC
		BTFSC	ADCON0,GO_DONE
		GOTO	WAIT_CH0_DAC	
								; DAC-OK
		MOVF	ADRES,W

		MOVWF	POWER_LEVEL_BAT
								; CHANNEL 0 - END
;*****
		BCF		ADCON0,ADON		; DISABLE ADC


		MOVF	POWER_LEVEL_BAT,W
		ANDLW	b'00001111'

	movwf	R2
	movwf	R4

	RLF	R2,1
	RLF	R2,1
	RLF	R2,0

	ADDWF	R4,0
	ADDWF	R4,0	
	movwf	R2	;	DECIMAL*10			
	
	movlw	.16
	movwf	R4
; .
;div_16		 ; R0 = R2 / R4
;  R2 .		
	CALL	div_16
	movf	R0,W

		CALL	LCDTable
		MOVWF	DISPLAY_S2





		SWAPF	POWER_LEVEL_BAT,W
		ANDLW	b'00001111'
		MOVWF   R2		; .
						;div_16		 ; R1:R0 = R3:R2 / R5:R4
						;  R3:R2 .

		MOVLW	.10
		MOVWF   R4
		CALL	div_16

		MOVF	R0,W
		CALL	LCDTable
		MOVWF	DISPLAY_S4

		MOVF	R2,W
		CALL	LCDTable
		MOVWF	DISPLAY_S3


		MOVLW		b'11111101'	;	XX.Xv
		MOVWF		DISPLAY_S5


		MOVLW		b'11100101'
		MOVWF		DISPLAY_S1



;> 15 V	
		MOVLW	.5
		XORWF	R2,W
		BTFSC	STATUS,Z
		BSF		FLAG_BEEP

		MOVLW	.6
		XORWF	R2,W
		BTFSC	STATUS,Z
		BSF		FLAG_BEEP

		MOVLW	.7
		XORWF	R2,W
		BTFSC	STATUS,Z
		BSF		FLAG_BEEP

;< 10 V	
		MOVLW	.0
		XORWF	R0,W
		BTFSC	STATUS,Z
		BSF		FLAG_BEEP

;< 12 V
		MOVLW	.1
		XORWF	R2,W
		BTFSC	STATUS,Z
		BSF		FLAG_BEEP


			RETURN
;**********************************************************************
TEMPERATUR_MODE
;**********************************************************************
		MOVLW		b'11001101'	;	XX.Xc
		MOVWF		DISPLAY_S1

;	      

		BTFSS	DISPLAY_S5,5
		GOTO	TEMPERATUR_MODE_1
;     

		MOVLW		b'11011101'	;	
		MOVWF		DISPLAY_S5

		MOVLW		b'11011111'	;	---C
		MOVWF		DISPLAY_S2
		MOVWF		DISPLAY_S3
		MOVWF		DISPLAY_S4

		CLRF		TEMP_CICLE1
		MOVLW		.128
		MOVWF		TEMP_CICLE2
		CALL		READ_TEMPERATURE_1ST



TEMPERATUR_MODE_1
;		MOVLW		b'11011101'	;	
;		MOVWF		DISPLAY_S5


		INCFSZ		TEMP_CICLE1,F
		RETURN	
		INCFSZ		TEMP_CICLE2,F
		RETURN

		MOVLW		.128
		MOVWF		TEMP_CICLE2

;		 

		CALL		READ_TEMPERATURE_2ST

;   
		CALL		READ_TEMPERATURE_1ST


;   


		BSF		DISPLAY_S5,2 ; DISABLE -


		SWAPF	fROM_ID1,0
		ANDLW	b'00001111'
		BTFSC	STATUS,Z
		GOTO 	NOTMINUS

		BCF		DISPLAY_S5,2 	; "-"

		COMF	fROM_ID0,1
		COMF	fROM_ID1,1
		
NOTMINUS		

		MOVF	fROM_ID0,0
		ANDLW	b'00001111'
		MOVWF	DECIMAL
		
		RRF	fROM_ID0,1
		RRF	fROM_ID0,1
		RRF	fROM_ID0,1
		RRF	fROM_ID0,1
		RRF	fROM_ID0,1
		RRF	TTEMP,1
		RRF	fROM_ID0,1
		RRF	TTEMP,1
		RRF	fROM_ID0,1
		RRF	TTEMP,1
		RRF	fROM_ID0,1
		RRF	TTEMP,1
		
		RRF	fROM_ID1,1
		RRF	TTEMP,1
		RRF	fROM_ID1,1
		RRF	TTEMP,1
		RRF	fROM_ID1,1
		RRF	TTEMP,1
		RRF	fROM_ID1,1
		RRF	TTEMP,1
		
; TEMPERATURA    =  TTEMP.DECIMAL

; .	;div_16 ; R1:R0 = R3:R2 / R5:R4
					;  R3:R2 .


	movf	TTEMP,W
	movwf	R2
	movlw	.10
	movwf	R4
		
	CALL	div_16

	movf	R0,W
		CALL	LCDTable
		MOVWF	DISPLAY_S4 ;  TTEMP/10

	movf	R2,W
		CALL	LCDTable
		MOVWF	DISPLAY_S3 ;  TTEMP/10
	
	
		

	movf	DECIMAL,W
	movwf	R2

	RLF	R2,1
	RLF	R2,1
	RLF	R2,0

	ADDWF	DECIMAL,0
	ADDWF	DECIMAL,0	
	movwf	R2	;	DECIMAL*10			
	
	movlw	.16
	movwf	R4
		
	CALL	div_16
	movf	R0,W

		CALL	LCDTable
		MOVWF	DISPLAY_S2	;	DECIMAL*10/16		


		

			RETURN
;**********************************************************************

DELAY_15MKS

	MOVLW	.3
	GOTO	delay

			RETURN
;**********************************************************************
SCAN_KEY
		BTFSC	KEY1_PIN
		CLRF	CNT_KEY1

		BTFSC	KEY2_PIN
		CLRF	CNT_KEY2

		BTFSS	KEY1_PIN
		INCF	CNT_KEY1,F

		BTFSS	KEY2_PIN
		INCF	CNT_KEY2,F

		BTFSC	CNT_KEY1,3
		GOTO	SCAN_KEY_1

		BTFSC	CNT_KEY2,3
		GOTO	SCAN_KEY_2

		RETURN
;FLAG_CHANGE_LEVEL_1
SCAN_KEY_1
		BSF		FLAG_CHANGE_LEVEL
		CLRF	CNT_KEY1
		BSF		FLAG_BEEP

		RETURN
SCAN_KEY_2
		BSF		FLAG_CHANGE_LEVEL_1
		CLRF	CNT_KEY2
		BSF		FLAG_BEEP

		RETURN

;**********************************************************************
TIME_MODE

		MOVLW	.5
		XORWF	cicle,W
		BTFSS	STATUS,Z
		RETURN


		INCFSZ	TEMP,F
		RETURN

		MOVLW	(.255-.25)
		MOVWF	TEMP

		MOVLW	.2
		MOVWF	EE_ADDR			; HOUR

		CALL	DSTIME_READ_BYTE	

		MOVF	EE_DATA,W
		CALL	LCDTable
		MOVWF	DISPLAY_S3

		SWAPF	EE_DATA,W
		CALL	LCDTable
		MOVWF	DISPLAY_S4



		MOVLW	.1
		MOVWF	EE_ADDR			; MIN

		CALL	DSTIME_READ_BYTE	

		MOVF	EE_DATA,W
		CALL	LCDTable
		MOVWF	DISPLAY_S1

		SWAPF	EE_DATA,W
		CALL	LCDTable
		MOVWF	DISPLAY_S2




		MOVLW	.0
		MOVWF	EE_ADDR			; SEC  . 

		CALL	DSTIME_READ_BYTE	


		MOVLW		.255
		MOVWF		DISPLAY_S5

		BTFSS	EE_DATA,0
		RETURN
		
		BCF		DISPLAY_S5,1
		BCF		DISPLAY_S5,4

		RETURN

;**********************************************************************
;**********************************************************************

READ_TEMPERATURE_1ST
		bcf	INTCON,	GIE		;  

       	call    Reset_1Wire

       	movlw   0xCC		;  
       	call    RW_Byte

       	movlw   0x44		;  
       	call    RW_Byte

		bsf	INTCON,	GIE		;   

		RETURN
; -------------------------------

READ_TEMPERATURE_2ST
		bcf	INTCON,	GIE		;  

      	call    Reset_1Wire
		
		movlw   0xCC		;  
       	call    RW_Byte

		CALL    Get_TEMP

		bsf	INTCON,	GIE		;   

		RETURN
		
;**********************************************************************



_INIT
;**********************************************************************
;  :                               *
;**********************************************************************
		BANK0
		BCF		ADCON0,	ADON	; Disable ADC

		CLRF 	PORTA 			; Initialize PORT by
		CLRF 	PORTB 			; clearing output
		CLRF 	PORTC			; data latches

		CLRF 	TMR0

		BSF 	STATUS, RP0 	; Select Bank 1
		MOVLW 	b'00000101'		;RA0,RA1 - ANALOG INPUT,RA3-Vref
		MOVWF 	ADCON1^80 		;Other - as digital 

		MOVLW 	b'00101101' 	; Value used to initialize data direction
		MOVWF 	TRISA^80 		;  

        MOVLW   B'00000111'		; PORTB   ;
        MOVWF   TRISB^80		  	;     

        MOVLW   B'00000000'		; PORTC   ;
        MOVWF   TRISC^80		  	;     

		  	;    
;******* 20 mHz
;				 >--------------PULL UP DISABLE			
;				 |>-------------RB0 INT 0 to 1 
;				 ||>------------TMR0 CONNECT TO CLK/4
;				 |||>-----------
;				 ||||>----------PRESCALER TO TMR0
;				 |||||>--\		   Prescaler -> Timer0,   
;				 ||||||>-->-----; 1:64, rising edge
;				 |||||||>/	
	movlw      b'01000101'		
	movwf      OPTION_REG^80	
;*****************
;    1
	BCF 	TXSTA^80,TXEN ;  OFF

; 				 >--------------IRQ PSP			
;				 |>-------------IRQ AD
;				 ||>------------IRQ USART RX
;				 |||>-----------IRQ USART TX
;				 ||||>----------IRQ SPP
;				 |||||>---------IRQ CPP1
;				 ||||||>--------IRQ TMR2
;				 |||||||>-------IRQ TMR1	        
;		MOVLW  b'11110000'	;

		MOVLW  b'00000000'	;  
		MOVWF	PIE1^80		;

;				 |      >-------IRQ CCP2	        
;		MOVLW  b'11110000'	;
		MOVLW  b'00000000'	;  IRQ MODULE
		MOVWF	PIE2^80		;


; SETUP TIMER2
	MOVLW	.255
	MOVWF	PR2^80

	BANK0

	MOVLW	b'00000111'
	MOVWF	T2CON




	BSF		_1WIRE     	;  1 WIRE 
	BCF 	RCSTA,SPEN	; USART OFF 

; 				 >--------------IRQ ON			
;				 |>-------------IRQ ON PEREPHERIAL
;				 ||>------------IRQ ON TMR0 
;				 |||>-----------IRQ ON RB0 INT
;				 ||||>----------OFF CHANGE PORTB
;				 |||||>---------
;				 ||||||>--------
;				 |||||||>-------	        
		MOVLW  b'10110000'	; IRQ ON
;		MOVLW  b'00000000'	; IRQ off
		MOVWF	INTCON		;
;**********************************************************************
;                                              *
;**********************************************************************

		CLRF	FLAG
		CLRF	DISPLAY_S1
		CLRF	DISPLAY_S2
		CLRF	DISPLAY_S3
		CLRF	DISPLAY_S4
		CLRF	DISPLAY_S5
		
		MOVLW	.10
		MOVWF	LIGHT


		BCF		BEEP_PIN	; OFF

		RETURN

;**********************************************************************

DISPLAY_CICLE

;      5 

		MOVLW	b'00000111';   
		ANDWF	PORTB,F

		MOVF	LIGHT,W
		XORWF	cicle,W

		BTFSC	STATUS,Z
		CLRF	cicle




;    
		MOVF	cicle,W		;  W  
;  
		btfsc   STATUS,Z
		GOTO 	MCICLE1

		MOVLW	.1
		XORWF	cicle,W	
		btfsc   STATUS,Z
		GOTO 	MCICLE2


		MOVLW	.2
		XORWF	cicle,W	
		btfsc   STATUS,Z
		GOTO 	MCICLE3

		MOVLW	.3
		XORWF	cicle,W	
		btfsc   STATUS,Z
		GOTO 	MCICLE4

		MOVLW	.4
		XORWF	cicle,W	
		btfsc   STATUS,Z
		GOTO 	MCICLE5

		INCF	cicle,F	

		RETURN		
					
MCICLE1:
		INCF	cicle,F		
		MOVLW	b'00000001'
		ANDWF	PORTC,F

		MOVF    DISPLAY_S1,W
		ANDLW	b'11111110'
		IORWF	PORTC,F	

		BSF		SEGMENT_1		;   

		RETURN

MCICLE2:
		INCF	cicle,F		
		MOVLW	b'00000001'
		ANDWF	PORTC,F

		MOVF    DISPLAY_S2,W
		ANDLW	b'11111110'
		IORWF	PORTC,F	

		BSF		SEGMENT_2		;   
		
		RETURN

MCICLE3:
		INCF	cicle,F		
		MOVLW	b'00000001'
		ANDWF	PORTC,F

		MOVF    DISPLAY_S3,W
		ANDLW	b'11111110'
		IORWF	PORTC,F	

		BSF		SEGMENT_3		;   
	
		RETURN

MCICLE4:
		INCF	cicle,F		
		MOVLW	b'00000001'
		ANDWF	PORTC,F

		MOVF    DISPLAY_S4,W
		ANDLW	b'11111110'
		IORWF	PORTC,F	

		BSF		SEGMENT_4		;   
	
		RETURN

MCICLE5:
		INCF	cicle,F
		
		MOVLW	b'00000001'
		ANDWF	PORTC,F

		MOVF    DISPLAY_S5,W
		ANDLW	b'11111110'
		IORWF	PORTC,F	

		BSF		SEGMENT_5		;   
		RETURN		
; *********************************************************************
;   I2C
; *********************************************************************
DSTIME_READ_BYTE
 	CALL    i2c_start
	MOVLW	0xD0
    MOVWF	_i2c_byte 	;          // control    WR
    CALL	i2c_write
    MOVF 	EE_ADDR,W
    MOVWF 	_i2c_byte    ;     
    CALL    i2c_write;  
    CALL    i2c_start;
	MOVLW	0xD1
    MOVWF	_i2c_byte    ;// control    RD
    CALL    i2c_write
    CALL    i2c_read
    CALL    i2c_stop
    MOVF 	_i2c_byte,W
    MOVWF 	EE_DATA

		RETURN

; *********************************************************************
DSTIME_SAVE_BYTE

    CALL        i2c_start
	MOVLW	0xD0
    MOVWF	_i2c_byte;        ; //control    WR
    CALL        i2c_write
    MOVF 	EE_ADDR,W
    MOVWF 	_i2c_byte         ;//    
    CALL        i2c_write  
    MOVF 	EE_DATA,W
    MOVWF 	_i2c_byte         ;//  
    CALL        i2c_write              
    GOTO        i2c_stop

;		RETURN

;**********************************************************************

; *********************************************************************
;     I2C   . 100 kHz  4  ; 
; *********************************************************************
;/*---------  -----------
;  2   - i2c_byte -    ,
;     ,    , 
;   ; tmp - ,   . */
; *********************************************************************
;char i2c_byte; /*   */
;char tmp;      /*  */

i2c_start
  			BANK1 		
            bcf 	TRIS_SDA          ; SDA - 
            bcf 	TRIS_SCL          ; SCL - 
  		BANK0  
  		bsf 	SCL     ; SCL - 1
		NOP
		NOP		
  		bsf 	SDA     ; SDA - 1
		NOP
		NOP	
		bcf 	SDA     ; SDA - 0
		NOP
		NOP		
  		bcf 	SCL    	; SCL - 0
	RETURN 
; ***********
i2c_stop
  		BANK0 
		bcf SDA     ; SDA - 0
		NOP
		NOP		
  		bsf SCL     ; SCL - 1
		NOP
		NOP	
  		bsf SDA     ; SDA - 1
	RETURN 
; ***********
i2c_write
			movlw 	0x08
            movwf 	_tmp
  			BANK1 		
            bcf 	TRIS_SDA          ; SDA - 
            bcf 	TRIS_SCL          ; SCL - 
   			BANK0
  			bcf 	SCL               ; SCL - 0
		NOP
		NOP		
send_bit  
  			bsf 	SDA     		; SDA - 1  1  SDA
		NOP
		NOP	
            btfss 	_i2c_byte, 7    ;   - 1 ?
 			bcf 	SDA          	;  -  0  SDA
		NOP
		NOP		
  			bsf 	SCL     		; SCL - 1
		NOP
		NOP		
            rlf 	_i2c_byte, F    ;    

        	bcf 	SCL          	; SCL - 0
		NOP
		NOP			
            decfsz 	_tmp, F        	;   ?
            goto 	send_bit        ;  - 
                       
         	bsf 	SDA          	; . SDA SDA - 1
		NOP
		NOP		
  			bsf 	SCL     		; SCL - 1,  ACK-    (!)
		NOP
		NOP		         
  			bcf 	SCL    			; SCL - 0 
	RETURN 
; ***********

i2c_read
            movlw 	0x08
            movwf 	_tmp
  			BANK1 
            bsf 	TRIS_SDA        ; SDA -  
           	bcf 	TRIS_SCL        ; SCL - 
  			BANK0 
       		bcf 	SCL          	; SCL -  0
		NOP
		NOP		

read_bit
			rlf 	_i2c_byte, F    ;   
  			bsf 	SCL     		; SCL - 1
		NOP
		NOP		
            bsf 	_i2c_byte, 0    ;    1 ; -NOP
		NOP
		NOP	
            btfss 	SDA        		; SDA - 1?
            bcf 	_i2c_byte, 0    ;  -    0

  			bcf 	SCL    			; SCL - 0
		NOP
		NOP		
            decfsz 	_tmp, F        	;   ?
            goto 	read_bit        ;  - 
  			BANK1 		
            bcf 	TRIS_SDA          ; SDA - 
   			BANK0
	RETURN 
; ***********
;**********************************************************************
INIT_TIMER
		CLRF	EE_DATA
		CALL	DSTIME_SAVE_BYTE 	;0

		INCF	EE_ADDR,F
		CALL	DSTIME_SAVE_BYTE	;1

		INCF	EE_ADDR,F
		CALL	DSTIME_SAVE_BYTE	;2

		INCF	EE_ADDR,F
		CALL	DSTIME_SAVE_BYTE	;3

		INCF	EE_ADDR,F
		CALL	DSTIME_SAVE_BYTE	;4

		INCF	EE_ADDR,F
		CALL	DSTIME_SAVE_BYTE	;5

		INCF	EE_ADDR,F
		CALL	DSTIME_SAVE_BYTE	;6

		INCF	EE_ADDR,F
		MOVLW	b'10010000'
		MOVWF	EE_DATA
		goto	DSTIME_SAVE_BYTE	;7

		;RETURN 


;----------------------------------------------------------------------
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@      MicroLAN   .                @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;
;********   4 MHZ   *************

;******************** MicroLAN ***************************
;   .
READ_ROM_CMD    equ  033h ;  " "
READ_R1990_CMD  equ  00Fh ;  DS1990A     33h.
MATCH_ROM_CMD   equ  055h ;  " ".
SKIP_ROM_CMD    equ  0CCh ;  " ".
;*********************************************************
; W=0 - 772 .
delay:
        movwf   fCOUNTER
D_Loop36:
        decfsz  fCOUNTER,1
        goto    D_Loop36
        return
;-----------------------------------------------------------------------------
Reset_1Wire:   ;     500 .
        bcf     _1WIRE
        movlw   .166
        call    delay ; 500 .
        bsf     _1WIRE
        CLRWDT   			;   		
;   .
        movlw   .166
        call    delay ; 500 .
        CLRWDT   			;   		
        return
;-----------------------------------------------------------------------------
; :
;  ,      fROM_ID0:fROM_ID7.
;   CRC -  C (CARRY)   STATUS .
Get_TEMP:
        clrf    CRC
;     .
;        call    Reset_1Wire
;   " ".
        movlw   0xBE
        call    RW_Byte
;  .
        movlw   0xFF
        call    RW_Byte ; byte 0.
        movwf   fROM_ID0
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 1.
        movwf   fROM_ID1
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 2.
        movwf   fROM_ID2
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 3.
        movwf   fROM_ID3
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 4.
        movwf   fROM_ID4
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 5.
        movwf   fROM_ID5
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 6.
        movwf   fROM_ID6
        call    DO_CRC
;  CRC.
        movlw   0xFF
        call    RW_Byte ; byte 7 (CRC).
        movwf   fROM_ID7
        subwf   CRC,1
        return
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
; :
;  ,      fROM_ID0:fROM_ID7.
;   CRC -  C (CARRY)   STATUS .
Get_ROM_ID:
        clrf    CRC
;     .
        call    Reset_1Wire
;   " ".
        movlw   READ_ROM_CMD
        call    RW_Byte
;  .
        movlw   0xFF
        call    RW_Byte ; byte 0.
        movwf   fROM_ID0
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 1.
        movwf   fROM_ID1
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 2.
        movwf   fROM_ID2
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 3.
        movwf   fROM_ID3
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 4.
        movwf   fROM_ID4
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 5.
        movwf   fROM_ID5
        call    DO_CRC
        movlw   0xFF
        call    RW_Byte ; byte 6.
        movwf   fROM_ID6
        call    DO_CRC
;  CRC.
        movlw   0xFF
        call    RW_Byte ; byte 7 (CRC).
        movwf   fROM_ID7
        subwf   CRC,1
        return

;-----------------------------------------------------------------------------
; - /   1-Wire.
;   W    W.
RW_Byte:
        movwf   fTEMP
        movlw   d'8' ; 8 .
        movwf   fBIT_CNT
RBLoop:
        bcf     _1WIRE ;  .
;  2 .
        CLRWDT   			;   		
        nop
        btfsc   fTEMP,0
        bsf     _1WIRE ;  .
        rrf     fTEMP,1
;  ~12 .
        movlw   3
        call    delay
        bcf     fTEMP,7 ;     TEMP,   .
        btfsc   _1WIRE
        bsf     fTEMP,7
;       .
        movlw   d'20'
        call    delay
;  .
        bsf     _1WIRE
; -   (  ).  Dallas  .
        movlw   d'1'      ;      .
        call    delay
;  8 ,  .
        decfsz  fBIT_CNT,1
        goto    RBLoop
;    W.
        movf    fTEMP,0
        return
;-----------------------------------------------------------------------------
;   CRC (  ).   W.
DO_CRC: ;  CRC - 8 .
        movwf   CRC
        movlw   0x08
        movwf   fBIT_CNT
        movf    CRC,0
DoCRC_Loop:
        xorwf   CRC,0
        movwf   fTEMP
        rrf     fTEMP,0
        movf    CRC,0
        btfsc   STATUS,0
        xorlw   0x18
        movwf   fTEMP
        rrf     fTEMP,0
        movwf   CRC
        bcf     STATUS,0
        rrf     CRC,1
        movf    CRC,0
        decfsz  fBIT_CNT,1
        goto    DoCRC_Loop
        return
;-----------------------------------------------------
;*****************************************************************************
;*                                                           *
;*****************************************************************************
		
; .
div_16_L	 ; R1:R0 = R3:R2 / R5:R4
;  R3:R2 .
		        clrf    R0
		        clrf    R1
		        movf    R4,w
		        btfss   STATUS,Z
		        goto    div16_Loop_L
		        movf    R5,w
		        btfss   STATUS,Z
		        goto    div16_Loop_L
		        return
div16_Loop_L:
		;  RR5:RR4  RR3:RR2.
		        movf    R4,w
		        subwf   R2,f     ; F = F - W
		        btfss   STATUS,C
		        decf    R3,f   ; .
		        btfsc   R3,7
		        goto    div16_exit_L
		        movf    R5,w
		        subwf   R3,f
		        btfss   STATUS,C
		        goto    div16_exit_L
		;    1.
		        movlw   1
		        addwf   R0,f
		        btfsc   STATUS,C
		        incf    R1,f
		        clrwdt
		        goto    div16_Loop_L
		; .
div16_exit_L:
		        movf    R4,w
		        addwf   R2,f
		;        btfss   STATUS,C
		        incf    R3,f   ; .
		        movf    R5,w
		        addwf   R3,f
		        return
;		;-----------------------------------------------------------------------------
;


;**********************************************************************

;*****************************************************************************
;*                                                           *
;*****************************************************************************

; .
div_16		 ; R0 = R2 / R4
;  R2 .
        clrf    R0
        movf    R4,w
        btfss   STATUS,Z
        goto    div16_Loop
        return
div16_Loop:
;  RR4  RR2.
        movf    R4,w
        subwf   R2,f     ; F = F - W
        btfss   STATUS,C
        goto    div16_exit

;    1.
        INCF	R0,f
        clrwdt
        goto    div16_Loop
; .
div16_exit:
        movf    R4,w
        addwf   R2,f
        return
;-----------------------------------------------------------------------------



;**********************************************************************


;**********************************************************************
;*********   1  *********************************************
;**********************************************************************


;**********************************************************************
			ORG     0x800 
;**********************************************************************
	NOP
	NOP
	NOP


;*********    *********************************************
;**********************************************************************
;                                                         *
;**********************************************************************


;**********************************************************************



	END                       ; directive 'end of program'

